#include <stdio.h>

/*
 * Implementierung der MODULO-Operation mittels %
 */
int mod(int a, int b) {
	int m = a % b;

	/* DIE AUSFUEHRLICHE VARIANTE:
	if (m < 0)
		m = m + b;

	return m;
	*/

	/*
	 * Kurzschreibweise mit Hilfe des Auswahl-Operators
	 * (ausfuehrlich siehe oben)
	 */
	return (m < 0) ? m + b : m;
}

int main() {
	int a = -5, b = 3;

	printf("a = %d\n", a);
	printf("b = %d\n", b);
	/*
	 * Ganzzahldivision: Ergebnis entsteht immer durch
	 * ABSCHNEIDEN der Nachkommastellen
	 * => evtl. ungewuenschtes Ergebnis fuer negative Zahlen
	 */
	printf("a / b = %d\n", a / b);
	/*
	 * so aehnlich wie MODULO, nur nicht ganz bei
	 * negativen Zahlen!
	 */
	printf("a %% b = %d\n", a % b);
	/*
	 * eigene MODULO-Implementierung (s.o.)
	 */
	printf("mod(a,b) = %d\n", mod(a,b));

	return 0;
}
